/* Chapter 9. Client/Server. SERVER PROGRAM. xx version
	Execute the command in the request and return a response. 
		Server [UserName GroupName]
	The command line OPTIONALLY contains the user and group names that
	this server will service and are used to determine the named pipe security. */

#include "EvryThng.h"

/* ClntSrvr.h defines the client and server names SERVER_PIPE and CLIENT_PIPE. */

#include "ClntSrvr.h"

VOID _tmain (int argc, LPTSTR argv [])
{
	BOOL Done = FALSE;
	HANDLE hNamedPipe, hTempFile;
	DWORD nXfer;
	STARTUPINFO StartInfo, StartInfoCh;
	SECURITY_ATTRIBUTES TempSA = {/*??*/, NULL, TRUE };
	LPSECURITY_ATTRIBUTES pNPSA = NULL;
	PROCESS_INFORMATION ProcInfo, BcstInfo;
	LPCTSTR TempFile = _T ("Results.tmp");
	FILE *fp;
	REQUEST Request;	/* Defined in ClntSrvr.h */
	RESPONSE Response;	/* Defined in ClntSrvr.h */

	DWORD AceMasks [] =	/* Named pipe access rights */
		{STANDARD_RIGHTS_REQUIRED | SYNCHRONIZE | 0X1FF, 0, 0 };

	/* Startup info for the child and parent processes. */

	GetStartupInfo (&StartInfo);
	GetStartupInfo (&StartInfoCh);

	/* Create a single named pipe instance for clients to communicate with.
		We will use ConnectNamedPipe to wait for clients to connect
		(connecting clients will be refused if a previous request is in process). */
	/*  First, create the security attributes, based on the
		[optional] user and group names on the command line.
		This is commented out and can be added if you want to
		use this feature.
		InitializeUnixSA is in Chapter 7 (or lab chapter 4)		*/

//	if (argc == 4)		/* Create a secure pipe. */
//		pNPSA = InitializeUnixSA (0440, argv [1], argv [2], AceMasks);

	hNamedPipe = ;

	/* Process (Program 9-4) to broadcast pipe name to clients. */

	CreateProcess (NULL, _T ("SrvrBcst./*??*/"), NULL, NULL,
			FALSE, 0, NULL, NULL, &StartInfo, &BcstInfo);

	while (!Done) {		/* Main Command Loop. */
		_tprintf (_T ("Server is awaiting next request.\n"));
		if ( !ReadFile (hNamedPipe, &Request, RQ_SIZE, &nXfer, NULL))
			ReportError (_T ("Connect or Read Named Pipe error."), 0, TRUE);
		_tprintf (_T ("Request is: %s\n"), Request.Record);

		Done = _tcscmp (Request.Record, _T ("$Quit")) == 0;

		if (Done) continue;	/* Stop the server on "$Quit" command. */

		/* Create a process to execute the command.
			Its output will go to temporary file. */

		hTempFile = ;

		StartInfoCh.hStdOutput = /*??*/;
		StartInfoCh.hStdError = /*??*/;

		if (/*??*/Create/*??*/ (NULL, Request.Record, NULL, NULL,
				TRUE, 0, NULL, NULL, /*??*/))
			PrintMsg (hTempFile,
					_T ("Server could not process request.\n"));
		else {
			CloseHandle (ProcInfo.hProcess);
		}
		CloseHandle (hTempFile);

		/* Send the temp file, one line at a time, to the client. */

		fp = _tfopen (TempFile, _T ("r"));
		while ((_fgetts (Response.Record, MAX_/*??*/, fp) != NULL))
			WriteFile (hNamedPipe, &Response.Record,
					(_tcslen (Response.Record) + 1) * TSIZE,
					&nXfer, NULL);
		fclose (fp);
		DisconnectNamedPipe (/*??*/);
		if (!DeleteFile (/*??*/))
			ReportError (_T ("Failed to delete temp file."), 0, TRUE);
	}	/* End of while loop and server operation. */

	/* Shut down the broadcast process. */

	TerminateProcess (BcstInfo./*??*/, 0);
	CloseHandle (/*??*/);
	DisconnectNamedPipe (/*??*/);
	CloseHandle(/*??*/);
	ExitProcess (0);
}
		 

