/* Chapter 14. compMPx. DEFECTIVE
	Background: "Windows Parallelism, Fast File Searching, and Speculative Processing"
	Written June 13, 2010, Johnson M. Hart. Copyright JMH Associates, Inc. 2010.
	More? See: http://www.informit.com/articles/article.aspx?p=1606242
	Laat modified June 23, 2010, primarily to simplify code based on Michael Bruestle's comments.
	Multithreaded file compare, similar to CMD's COMP command, but no options are supported.
	    Also, there's no prompt for a second pair of files after comparing the first pair.
		Finally, the search is terminated after 8 mismatches are detected (8 is an arbitrary number
		used to illustrate speculative processing.)
	Use threads as an alternative to overlapped I/O. 
	Also, memory map the files rather than use normal I/O.
	This is expected to improve performance.
	There are extra options to allow experimentation with the block size and the number of work items.
	Reference: Windows System Programming Edition 4, Chapters 5, 7-10, and 14.
	Final note: This program requires NT kernel 6.x (Vista, Windows 7, Server 2008, ...
	It will NOT run under Windows XP. This restriction allows us to use SRW locks and other features. */
/* compMT file1 file2 [ blockSize [, nStripes ] ] 
           file1, file2: pathnames for the two files to compare
           blockSize: Size of each block (buffer). Default: 4,096. Always use a power of two. Must be >= 8
           nStripes: Number of independent stripes (parallel work items to compare the files)
                     Default: Number of processors on this system.
					 if nStripes < 0, then use conventional file processing (ReadFile), with the block size.
						This feature is included to allow baseline comparison.
						The implementation is single threaded.
					 ENHANCEMENT: If the file size is too large compared to physical memory, use the conventional]
						file processing solution. See "Windows Parallelism, Fast File Searching, and Speculative Processing"
						for more information.
					 ADDITIONAL ENHANCEMENT. Try thread pooling

    The two files are processed with work item 0 processing blocks 0, nStripes, 2*nStripes, ...
                                     work item 1 processing blocks 1, nStripes+1, 2*nStripes+1, ...
                                and so on.
 */
 /* Comment: This program may fail for large files, especially on 32-bit systems
  * where you have, at most, 3 GB to work with (of course, you have much less
  * in reality, and you need to map two files). NOTE: At this time, nearly all
  * new systems on the market are 64-bit, although legacy systems will be around for some time.
  *
  * This program works by mapping the input and output files in their entirity.
  * You could enhance this program by mapping one block at a time for each file,
  * much as blocks are used in the ReadFile/WriteFile implementations. This would
  * allow you to deal with very large files on 32-bit systems. I have not taken
  * this step and leave it as an exercise. 
  */

